#include "power_supply.h"

//-------------------------------------------------------------
//------------------ADC interrupt complete vector--------------
ISR(ADC_vect){
	auto unsigned char i;
	auto unsigned int temp_adc = 0;

	//-------------ADC calculation-----------------

	//Update adc_buf from ADC register 
	adc_buf[adc_buf_pointer++] = ADCW;

	//Mask Buf pointer 
	adc_buf_pointer &= 0x0F;
	
	//Calculate Adc_value from ADC buffer
	for(i=0 ; i<16; i++ ){

		temp_adc += adc_buf[i]; 		
	}	 
	
	Adc_value = ((temp_adc>>4) & 0x3FF);
	
	//-------------PWM calculation-----------------

	if(Adc_value < target_adc){
   	target_pwm++;
	}
	else if(Adc_value > target_adc){
		target_pwm--;
	}
	
	if(target_pwm>1023){
  		target_pwm=1023;
	}

	//-------------Update PWM----------------------
		
	//Set new PWM value
	SetPwm(target_pwm);
}

//-------------------------------------------------------------
//---------------------main Program Begin----------------------
int main(void){

	//Init ADC converter    
	AdcInit();

	//Start PWM with init value 1023
   PwmStart(1023);

	//Enable Global Interrupts
	sei();
	
	//Init LCD
	LcdInit();
	
	//Ovdje upises zeljenu vrijednost za ADC
	target_adc = 20;
	
	//Forever Loop
   while(1){  
		
		//delay for LCD refresh      
		_delay_ms(300);
		
		//refresh LCD
		LcdRefresh();        
    }
}
//-------------------------------------------------------------

 
 
 
 
 
 
        
       

      
  
